#include "smear.h"

main(int argc, char **argv)
{
	if (argc != 3)
	{
		fprintf(stderr, "Usage: smearrun (m|c|w|p) file\n");
		exit(0);
	}

	switch (argv[1][0])
	{
	case 'm': case 'M':
		SmearAPI(
		ssmSetNextMove(argv[2]);
		break;

	case 'c': case 'C':
		ssmSetNextColor(argv[2]);
		break;

	case 'w': case 'W':
		ssmSetNextWaveform(argv[2]);
		break;

	case 'p': case 'P':
		ssmSetNextParticle(argv[2]);
		break;

	default:
		fprintf(stderr, "Usage: smearrun (m|c|w|p) file\n");
	}

	exit(0);
}
