#include "smear.h"

extern	int	isCheck;

int	gcount = 0;
int	pcount = 0;

void
TestAll(char *match)
{
	WIN32_FIND_DATA		fnd;
	HANDLE				fnd_handle;
	DWORD				taa;				
	int				count;
	char				pathstart[1024];
	char				workingname[1024];
	char				*p;

	if ((p = strchr(match, '\\')) == (char *)0)
		pathstart[0] = '\0';
	else
	{
		strcpy(pathstart, match);
		*(strrchr(pathstart, '\\') + 1) = '\0';

	}

	fnd_handle = FindFirstFile(match, &fnd);

	count = 0;

	if (fnd_handle != INVALID_HANDLE_VALUE)
	{
		do
		{
			strcpy(workingname, pathstart);
			strcat(workingname, fnd.cFileName);
			count++;
			if (((taa = GetFileAttributes(workingname)) == 0xFFFFFFFF) || (taa & FILE_ATTRIBUTE_DIRECTORY))
			{
				// fprintf(stderr, "%s: Invalid file type\n", fnd.cFileName);
				continue;
			}

			gcount++;
			if (ParseFile(workingname) == (void *)0)
				fprintf(stderr, "%s: FAILED\n", workingname);
			else
			{
				fprintf(stderr, "%s: Passed\n", workingname);
				pcount++;
			}

		} while (FindNextFile(fnd_handle, &fnd) == TRUE);

		FindClose(fnd_handle);
	}

	if (count == 0)
		fprintf(stderr, "%s: No match\n", match);


	return;
}

main(int argc, char **argv)
{
	int	i;

	fprintf(stderr, "smeartst: Smear/Stutter Grammatical Checker (c) 2000 mykel\n");

	if (argc < 2)
	{
		fprintf(stderr, "\nTest Smear script files for grammatical correctness\n\n");
		fprintf(stderr, "Usage: smeartst [file ...]\n");
		exit(0);
	}
	isCheck = 1;

	gcount = 0;

	for (i = 1; i < argc; i++)
		TestAll(argv[1]);

//	printf("%d of %d File%s passed\n", gcount, (gcount == 1) ? "" : "s");
}
