//////////////////////////////////////////////////////////////////////////////////////
//
// songname.cpp
//
// This file has to be a CPP file because it handles the query class.
//
//////////////////////////////////////////////////////////////////////////////////////

#include "smear.h"

static	class QueryInterface	*__qip = (class QueryInterface *)0;

extern	"C"	void
C_SetupQuery(void *p)
{
	__qip = (class QueryInterface *)p;
}


extern	"C"	void
C_CheckSongName(char *songName, char *songArtist, int *songNameChanged)
{
	char	*song;
	char	*artist;
	char	tsong[1024];
	char	tartist[1024];
	char	*p;

	if (__qip == (class QueryInterface *)0)
		return;

	song = __qip->QueryString("currentsongtitle");
	if (!song)
	{
		*songArtist = *songName = '\0';
		return;
	}

	strcpy(tsong, song);
	__qip->FreeString(song);

	artist = __qip->QueryString("currentsongauthor");

	if (!artist)
	{
		*songArtist = *songName = '\0';
		return;
	}

	strcpy(tartist, artist);
	__qip->FreeString(artist);

	if (strcmp(tsong, tartist) == 0)
	{
		if ((p = strstr(tartist, " / ")) != (char *)0)
		{
			*p = '\0';
			p += 3;
		}
		else
		if ((p = strchr(tartist, '/')) != (char *)0)
			*(p++) = '\0';
		else
			p = song;

		strcpy(tsong, p);
	}

	if (strcmp(songName, tsong) != 0 || strcmp(songArtist, tartist) != 0)
	{
		strcpy(songName, tsong);
		strcpy(songArtist, tartist);
		*songNameChanged = 0;
	}
}
