extern	unsigned long	font_bitmap[];
extern	int	letter_offsets[3][33];

// Font Bitmap is 2048 * 258

GetFontPoint(int x, int y)
{
	int byte = y * 64 + (x >> 5);
	unsigned long mask = (unsigned long)0x80000000 >> (x & 0x1f);

	return ((*(font_bitmap + byte)) & mask);
}


fontDrawAA(int x, int, y, int height, unsigned char c, int color)
{
	int	line = (c >> 5) - 1;
	int	let = c & 0x1f;
	int	width;
	int	xstart;
	int	ystart;
	int	d1, d2, d3, d4;
static	char	draw[] = " .~+&#@@";
	int	y, x, ry, rx, v;

	if (c < 32 || c > 127)
		return;

	width = letter_offsets[line][let + 1] - letter_offsets[line][let];

	width = width * height / 86;

	ystart = line * 86;
	xstart = letter_offsets[line][let];

	for (y = 0; y < height; y++)
	{
		ry = (y << 16) * 86 / height;
		for (x = 0; x < width; x++)
		{
			rx = (x << 16) * 86 / height;

			d1 = GetFontPoint(xstart + (rx >> 16), ystart + (ry >> 16)) ? 255 : 0;
			d2 = GetFontPoint(xstart + (rx >> 16) + 1, ystart + (ry >> 16)) ? 255 : 0;
			d3 = GetFontPoint(xstart + (rx >> 16), ystart + (ry >> 16) + 1) ? 255 : 0;
			d4 = GetFontPoint(xstart + (rx >> 16) + 1, ystart + (ry >> 16) + 1) ? 255 : 0;

			d1 = d1 + (((d2 - d1) * (x & 0xffff)) >> 16);
			d3 = d3 + (((d4 - d3) * (x & 0xffff)) >> 16);

			v = d1 + (((d3 - d1) * (y & 0xffff)) >> 16);

			putchar(draw[v & 0x7]);
		}
		putchar('\n');
	}

	return x + width;
}
